#include "..\inc\swilib.h" //  . -    .
#include "font.h" // 
#include "pp.h" // 

#define RGB8(R,G,B) (B+(G<<2)+(R<<5))

extern char* screen; //  132*176
extern int screensize;
extern void DrawScreen(); //   


const char colors[]={ // 
  RGB8(0,0,0),RGB8(0,0,6),RGB8(0,5,0),RGB8(0,6,3),  //black,     blue,         green,       cyan
  RGB8(7,0,0),RGB8(6,0,3),RGB8(5,4,1),RGB8(5,5,2),  //red,       magenta,      brown,       lightgray
  RGB8(3,3,1),RGB8(2,2,7),RGB8(1,7,1),RGB8(3,7,3),  //darkgray,  lightblue,    lightgreen,  lightcyan
  RGB8(7,3,1),RGB8(7,3,7),RGB8(7,7,0),255           //lightred,  lightmagenta, yellow,      white
};

#define BLACK        colors[0]
#define BLUE         colors[1]
#define GREEN        colors[2]
#define CYAN         colors[3]
#define RED          colors[4]
#define MAGENTA      colors[5]
#define BROWN        colors[6]
#define LIGHTGRAY    colors[7]
#define DARKGRAY     colors[8]
#define LIGHTBLUE    colors[9]
#define LIGHTGREEN   colors[10]
#define LIGHTCYAN    colors[11]
#define LIGHTRED     colors[12]
#define LIGHTMAGENTA colors[13]
#define YELLOW       colors[14]
#define WHITE        colors[15]


volatile int running=0; //  
const int CLR=0, PUSH=1;
enum {x=0,y=1,height,width,color,speed,lifetime,dx,dy}; //     
enum {pause=0,game=1,menu,set_ai,set_r}; //  
enum {easy,normal,hard}; //  
byte status,ai_lev,rack_lev;
byte change; //-     ( )

byte user[8]; // dx  ... 0-; 1 -  ; 2 -... 
byte cpu[7];
int ball[9];
byte timer_speed;
byte max_height, max_width;
byte AI_line;
byte lives;

char str_menu[14][14] = {
  "-=PP 1.0=-",    //0
  "1: set AI",      //1
  "2: set racket",  //2
  "0: back",        //3
  "-------------",  //4
  "(c) Stinger25",  //5
  "thanks to:",     //6
  "Cbn & KreN",     //7
  "set AI",         //8
  "set racket",     //9
  "1: easy",        //10
  "2: normal",      //11
  "3: hard",        //12
  "& Rush",        //13

};



GBSTMR timer;
void timer_proc(void){ //     N   
  if(running){
    REDRAW(); //  
    GBS_StartTimerProc(&timer,timer_speed,timer_proc); //     N   ... N=262/timer_speed
   //        
  }
}


void onredraw(void){ //  
  if (running) {
   move_ball();
   move_block();
  }
}


// keycode -  , pressed - //
int onkey(unsigned char keycode, int pressed){ //   .  0  1  
  unsigned char key;
  key=keycode;
  switch(pressed){      
  case KEY_UP: //return 0; //  
      user[dx]=0; break;

  case LONG_PRESS: //    ()
  case KEY_DOWN: //  
   if (status==game){
    switch(key){      
      case RED_BUTTON: return 1; //  RIGHT_SOFT
      case RIGHT_SOFT: drawmenu(menu); break; 
      case LEFT_BUTTON: case '4': 
       user[dx]=1; move_block(); break;
      case RIGHT_BUTTON: case '6': 
       user[dx]=2; move_block(); break;
      case '0': setpause(); break; 
    }key='\0';
   }
   if (status==menu){ 
    switch(key){      
      case '1': drawmenu(set_ai); break;
      case '2': drawmenu(set_r); break;
      case '0': setpause(); break;     
    }key='\0';
   }
   if (status==set_ai){
     switch(key){      
      case '1': ai_lev=easy; change=1; drawmenu(menu); break;
      case '2': ai_lev=normal; change=1; drawmenu(menu); break;     
      case '3': ai_lev=hard; change=1; drawmenu(menu); break;     
      case '0': drawmenu(menu); break;     
    }key='\0';
   }
   if (status==set_r){
    switch(key){      
      case '1': rack_lev=easy; change=1; drawmenu(menu); break;
      case '2': rack_lev=normal; change=1; drawmenu(menu); break;     
      case '3': rack_lev=hard; change=1; drawmenu(menu); break;     
      case '0': drawmenu(menu); break;     
    }key='\0';
   }
  }
  DrawScreen(); //  
  return 0;
}


void onclose(){ //  
    running=0; //     
//  GBS_StopTimer(&timer); //    pickoff,  ,  .
}


void onexit(){ // 
}


void oncreate(){ //  
    running=1;
    status=game;
    GBS_StartTimerProc(&timer,timer_speed,timer_proc); //     N       
}


int onstart(void){ //  .  0  1  .
  init();
  return 0;
}

/////////////////////////////////////////////////////////////////////////////

void drawbox(byte x0, byte y0, byte height, byte width, char color){ //   
  int i,j;
  char *s;
  int x=max_width;
  s=screen+y0*x+x0;
    for(i=height;i>0;i--,s+=x) {
      for(j=1; j<=width;j++)
      {
        s[j-1]=color;}
    }
    s=screen+(y0+height)*x+x0;
    memset(s,color,height*width);
}


void drawmenu(byte mode) // 
{ int i,j;
  zeromem(screen,screensize);
  status=mode;
  running=0;
  
  switch(mode) {  
    case menu: 
      outtextxy(21,14,str_menu[0]); 
      j=0; 
       for(i=1;i<8;i++)
         {j++; outtextxy(12,j*10+20,str_menu[i]);}
      outtextxy(21,100,str_menu[13]); 
    break;
      
    case set_ai: 
      outtextxy(21,14,str_menu[8]); 
      j=1;
       for(i=10;i<13;i++)
         {outtextxy(12,j*10+20,str_menu[i]);j++;}
      outtextxy(12,j*10+20,str_menu[3]); 
     break;
    
    case set_r: 
     outtextxy(21,14,str_menu[9]); 
     j=1;
     for(i=10;i<13;i++)
       {outtextxy(12,j*10+20,str_menu[i]);j++;}
     outtextxy(12,j*10+20,str_menu[3]); 
     break;        
  }  
}

void move_block() //     
{
  if (running) {
    if (user[dx]==1) //
      {shift_block(0,CLR,0); shift_block(0,PUSH,-user[speed]);}

    if (user[dx]==2) //   
      {shift_block(0,CLR,0); shift_block(0,PUSH,user[speed]);}   
  }
}

// //   
void shift_block(int mode,int act,int shift){ //mode=[0-user|1-cpu]; act=[0-CLR|1-PUSH]; shift-   
  byte col;
  
  if (act) 
   { if (mode)
      {col=cpu[color];}
     else
      {col=user[color];}       
   }
  else
   {col=BLACK;} 
  if (mode) {
    if ((cpu[x]<cpu[speed])&&(shift<0)) {cpu[x]=0;}
    else {if (shift<0) cpu[x]+=shift;}
    if (((cpu[x]+shift+cpu[width])>max_width)&&(shift>0))  {cpu[x]=max_width-cpu[width];}
    else {if (shift>0) cpu[x]+=shift;}
   drawbox(cpu[x],cpu[y],cpu[height],cpu[width],col);}
  else {    
    if ((user[x]<user[speed])&&(shift<0)) {user[x]=0;}
    else {if (shift<0) user[x]+=shift;}
    if (((user[x]+shift+user[width])>max_width)&&(shift>0))  {user[x]=max_width-user[width];}
    else {if (shift>0) user[x]+=shift;}   
    drawbox(user[x],user[y],user[height],user[width],col);   
  }
}

void move_ball() //         
{
  drawbox(ball[x],ball[y],ball[height],ball[width],BLACK);   
  drawbox(user[x],user[y],user[height],user[width],user[color]);   
  drawbox(cpu[x],cpu[y],cpu[height],cpu[width],cpu[color]);
  
//      
  if ((ball[x]>=(user[x]-ball[width]))&&(ball[x]<=(user[x]+user[width]))&&((ball[y]+ball[dy])>(user[y]-ball[height]))) 
    { 
      ball[dy]*= -1;
      if (((ball[x]<=user[x]+ball[width]/2)&&(ball[dx]>0)) || ((ball[x]>=(user[x]+user[width]-ball[width]/2))&&(ball[dx]<0)))
        {ball[dx]*= -1;  ball[y]=user[y]-ball[height];} //                
      else{ //     
        if (ball[x]<(user[x]+user[width]/2)) {  //         
          if (ball[dx]>0) {
            switch (user[dx]) {
            case 0: case 1: ball[dx]+=1; break;
            case 2: ball[dx]-=1; break;
            }}
          if (ball[dx]<0) {
            switch (user[dx]) {
            case 1: ball[dx]+=1; break;
            case 0: case 2: ball[dx]-=1; break;
            }}
        }else{ //   
          if (ball[dx]>0) {
            switch (user[dx]) {
            case 1: ball[dx]-=1; break;
            case 0: case 2: ball[dx]+=1; break;
            }}
          if (ball[dx]<0) {            
            switch (user[dx]) {
            case 0: case 1: ball[dx]-=1; break;
            case 2: ball[dx]+=1; break;
            }}            
            ball[dx]+=1;}
        }
      }
  
//   ""     
  if ((ball[x]>=cpu[x])&&(ball[x]<=(cpu[x]+cpu[width]))&&((ball[y]+ball[dy])<(cpu[y]+cpu[height]))) 
    {ball[dy]*= -1;
      if (((ball[x]<=cpu[x]+ball[width]/2)&&(ball[dx]>0)) || ((ball[x]>=(cpu[x]+cpu[width]-ball[width]/2))&&(ball[dx]<0)))
        {ball[dx]*= -1;  ball[y]=cpu[y]+cpu[height];} //                
      else
      {
        if (ball[x]<(cpu[x]+cpu[width]/2)) {  //         
          ball[dx]-=1;
        }else{//  
          ball[dx]+=1;          
        }
      }
    }
  
//   x
  if (ball[dx]>4) {ball[dx]=4;}
  if (ball[dx]<-4) {ball[dx]=-4;}

//        
  if ((ball[x]+ball[dx])<3) //   
    {  ball[x]=1;
       ball[dx]*= -1;     
    } else {
       ball[x]+=ball[dx]; 
    }

  if ((ball[x]+ball[dx])>=(max_width-4)) //
    { ball[x]=max_width-ball[width];
      ball[dx]*= -1;
    } else {
       ball[x]+=ball[dx]; 
    }
  
  ball[y]+=ball[dy];
//  drawbox(ball[x],ball[y],ball[height],ball[width],ball[color]);
  drawbox(ball[x]+1,ball[y],ball[height],ball[width]-2,ball[color]);
  drawbox(ball[x],ball[y]+1,ball[height]-2,ball[width],ball[color]);
 
  AI();  //  
  win(); //   - ? ..   "" 
}


void AI(){ //    :)   CPU     AI_line
  int sp=0;

  if (ball[y] <AI_line) {     
    shift_block(1,CLR,0);
    if (ball[x]>(cpu[x]+(cpu[width]/4)*3)) {sp=cpu[speed];}
    if (ball[x]<=(cpu[x]+cpu[width]/4)) {sp=-cpu[speed];}
    shift_block(1,PUSH,sp);
  }
  else { //    
    if (cpu[x]<(cpu[width]/2)){shift_block(1,CLR,0); shift_block(1,PUSH,cpu[speed]);}
    if (((cpu[x]+cpu[width]/2))>(max_width-cpu[width]/2)) {shift_block(1,CLR,0); shift_block(1,PUSH,-cpu[speed]);}
  } 
}


void win() //    -... 
{  
  char tmp[12];

  if (ball[y]>(user[y]+user[height]/2)) {--user[lifetime]; setgame(0);}
  if (ball[y]<(cpu[y]+cpu[height]/2)) {--cpu[lifetime]; setgame(0);}    
  
  if (user[lifetime]==0) {ShowMSG(1,(int)" "); setgame(1);}
  if (cpu[lifetime]==0) {ShowMSG(1,(int)" "); setgame(1);}

  sprintf(tmp,"you:%d  cpu:%d",user[lifetime],cpu[lifetime]);
  outtextxy(2,1,tmp); 
}


//   
void setgame(byte newgame) //1-newgame; 0-continue
{
  if (!newgame) {
    drawbox(user[x],user[y],user[height],user[width],BLACK);
    drawbox(cpu[x],cpu[y],cpu[height],cpu[width],BLACK);
    drawbox(ball[x],ball[y],ball[height],ball[width],BLACK); 
  }
  
  switch (ai_lev){
  case easy:   AI_line=65; break;
  case normal: AI_line=70; break;
  case hard:   AI_line=75; break;
  }
    
  if (newgame) 
    lives=7;
  
  user[x]=51;
  user[y]=max_height-15;
  switch (rack_lev) {
  case easy:   
    user[height]=6;
    user[width]=35;
    user[speed]=7;
    break;
  case normal: 
    user[height]=5;
    user[width]=30;
    user[speed]=5;
    break;
  case hard:   
    user[height]=4;
    user[width]=25;
    user[speed]=5;
    break;
  }
  user[color]=LIGHTGRAY;  
  user[dx]=0;
  if (newgame)
    user[lifetime]=lives;

  cpu[x]=51;
  cpu[y]=10;
  switch (rack_lev) {
  case easy:   
    cpu[height]=5;
    cpu[width]=30;
    cpu[speed]=5;
    break;
  case normal: 
    cpu[height]=5;
    cpu[width]=30;
    cpu[speed]=6;
    break;
  case hard:   
    cpu[height]=6;
    cpu[width]=35;
    cpu[speed]=6;
    break;
  }
  cpu[color]=LIGHTGRAY;  
  if (newgame)
    cpu[lifetime]=lives;
  
  ball[x]=10;
  ball[y]=50;
  ball[height]=ball[width]=4;
  ball[color]=YELLOW;
  ball[dx]=1;
  ball[dy]=4;
  
  zeromem(screen,screensize); //clear screen  

  drawbox(user[x],user[y],user[height],user[width],user[color]);
  drawbox(cpu[x],cpu[y],cpu[height],cpu[width],cpu[color]);
}

void init(){ // . .
  max_height = ScreenH();
  max_width = ScreenW();
  timer_speed=15;
  ai_lev=rack_lev=normal;
  
  setgame(1); // ... ..-

}

void setpause() //   ?
{ 

  if(running) {
    running=0; 
    outtextxy(max_width/2-18,max_height/2-4,"PAUSE");
  }else{
    if (change){change=0; setgame(1);}
    status=game;            
    running=1;     
    zeromem(screen,screensize);
    timer_proc();
  }
}

void drawsym(char *out, char c){ //   out = screen
  int i,j;
  byte b, *bptr=(byte*)font+((c-=0x20)<=0?0:(c<<3));
  for(j=0;j<8;j++){
    b=*bptr++;
    for(i=0;i<8;i++){
      *out++=(b&0x80)?0xff:0; //colors
      b<<=1;
    }
    out+=max_width-8;
  }
}

void outtextxy(byte x, byte y, char* str){ //      x & y
  int i=0;
  while(str[i]){
    drawsym(screen+max_width*y+i*8+x,str[i]);
    i++;
   }
}
